<?php

 
/**
 * Implements hook_views_data().
 */
function fb_event_views_data() {
  
  $data = array();

  $data['fb_event_rsvp']['table']['group']  = t('Facebook event');
  
  // Advertise this table as a possible base table
  $data['fb_event_rsvp']['table']['base'] = array(
    'field' => 'id',
    'title' => t('Facebook event'),
    'help' => t('Facebook event RSVP details.'),
    'weight' => 10,
  );
  
  $data['fb_event_rsvp']['table']['join'] = array(
    'node' => array(
      'left_field' => 'nid',
      'field' => 'nid',
    ), 
    'users' => array(
      'left_field' => 'uid',
      'field' => 'uid',
    ),
  );

  $data['fb_event_rsvp']['nid'] = array(
    'title' => t('Facebook event nid'),
    'help' => t('Facebook event nid.'),
    'relationship' => array(
      'base' => 'node',
      'field' => 'nid',
      'handler' => 'views_handler_relationship',
      'label' => t('Facebook event'),
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
    ),
  );
  
  $data['fb_event_rsvp']['fbeid'] = array(
    'title' => t('Facebook event ID'),
    'help' => t('Facebook event ID.'),
    'field' => array(
      'handler' => 'views_handler_field',
    ),
    'filter' => array(
        'handler' => 'views_handler_filter_string',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  
  $data['fb_event_rsvp']['uid'] = array(
    'title' => t('Facebook event User'),
    'help' => t("User who participating to this event"),
    'relationship' => array(
      'base' => 'users',
      'field' => 'uid',
      'handler' => 'views_handler_relationship',
      'label' => t('Facebook event User'),
    ),
  );

  $data['fb_event_rsvp']['rsvp'] = array(
    'title' => t('RSVP status'),
    'help' => t('Facebook event: RSVP status.'),
    'field' => array(
      'handler' => 'views_handler_field',
    ),
    'filter' => array(
        'handler' => 'views_handler_filter_string',
    ),
		'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  $data['fb_event_rsvp']['fbuid'] = array(
    'title' => t('RSVP facebook user ID'),
    'help' => t('Facebook event: RSVP facebook user ID.'),
    'field' => array(
      'handler' => 'views_handler_field',
    ),
    'filter' => array(
        'handler' => 'views_handler_filter_string',
    ),
		'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  
  return $data;
  
}


/**
 * 
 */
function fb_event_views_data_alter(&$data) {
  
  $data['node']['fb_event_rsvp'] = array(
    'title' => t('RSVP of the event'),
    'help' => t('Relate all RSVP of the event'),
    'relationship' => array(
      'group' => t('Facebook event'),
      'label' => t('Facebook event RSVP details'),
      'base' => 'fb_event_rsvp',
      'base field' => 'nid',
      'relationship field' => 'nid',
      'handler' => 'views_handler_relationship',
    ),
  );
  
  $data['users']['fb_event_rsvp'] = array(
    'title' => t('RSVP of the user'),
    'help' => t('Relate all RSVP of a user'),
    'relationship' => array(
      'group' => t('Facebook event'),
      'label' => t('Facebook event RSVP details'),
      'base' => 'fb_event_rsvp',
      'base field' => 'uid',
      'relationship field' => 'uid',
      'handler' => 'views_handler_relationship',
    ),
  );
  
}

/*
function fb_event_field_views_data_alter( &$result, &$field, $module) {
  
  if ($field['field_name'] != 'field_fbeid') {
    return;
  }
  
  $fields = field_info_fields();
  
  if ( !isset($fields['field_fbeid']) ){
    return;
  }
  
  $field = $fields['field_fbeid'];
  
  $db_columns = $field['storage']['details']['sql'][FIELD_LOAD_CURRENT];
  
  $table = _field_sql_storage_tablename($field);
  $column_name = '';

  foreach ($db_columns as $key => $attributes) {
    $column_name = $attributes['value'];
    break;
  }
  
  if ( empty($column_name) ) {
    return;
  }
  
  $result[$table]['field_fbeid']['relationship'] = array(
    'title' => t('Facebook event'),
    'help' => t("Bring information about the Facebook event."),
    'base' => 'fb_event_rsvp',
    'field' => 'fbeid',
    'handler' => 'views_handler_relationship',
    'label' => t('Facebook event'),
  );
  
  //print_r($result);
  //exit();
}
*/
